import sqlite3

__package_dir = os.path.dirname(__file__)
__db_path = os.path.join(__package_dir, "tic_tac_toe.db")

with sqlite3.connect(__db_path) as conn:
    conn.execute("""
    CREATE TABLE IF NOT EXISTS "matches" (
        "match_id"	INTEGER NOT NULL,
        "player1_id"	INTEGER NOT NULL,
        "player2_id"	INTEGER NOT NULL,
        "start_time"	TEXT NOT NULL,
        "end_time"	TEXT NOT NULL,
        "board"	TEXT NOT NULL,
        "winner_id"	INTEGER,
        PRIMARY KEY("match_id" AUTOINCREMENT)
    )
    """)

    conn.execute("""
    CREATE TABLE IF NOT EXISTS "players" (
        "player_id"	INTEGER NOT NULL,
        "username"	TEXT NOT NULL UNIQUE,
        "num_wins"	INTEGER NOT NULL DEFAULT 0,
        PRIMARY KEY("player_id" AUTOINCREMENT)
    )
    """)

    conn.execute("""
    DROP TRIGGER IF EXISTS matches_after_insert
    """)

    conn.execute("""
    CREATE TRIGGER matches_after_insert
    AFTER INSERT ON matches
    FOR EACH ROW
    BEGIN
        UPDATE players
        SET num_wins = num_wins + 1
        WHERE player_id = NEW.winner_id;
    END
    """)
